//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// SchemaThingsPropertiesUpdateOKCode is the HTTP code returned for type SchemaThingsPropertiesUpdateOK
const SchemaThingsPropertiesUpdateOKCode int = 200

/*SchemaThingsPropertiesUpdateOK Changes applied.

swagger:response schemaThingsPropertiesUpdateOK
*/
type SchemaThingsPropertiesUpdateOK struct {
}

// NewSchemaThingsPropertiesUpdateOK creates SchemaThingsPropertiesUpdateOK with default headers values
func NewSchemaThingsPropertiesUpdateOK() *SchemaThingsPropertiesUpdateOK {

	return &SchemaThingsPropertiesUpdateOK{}
}

// WriteResponse to the client
func (o *SchemaThingsPropertiesUpdateOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(200)
}

// SchemaThingsPropertiesUpdateUnauthorizedCode is the HTTP code returned for type SchemaThingsPropertiesUpdateUnauthorized
const SchemaThingsPropertiesUpdateUnauthorizedCode int = 401

/*SchemaThingsPropertiesUpdateUnauthorized Unauthorized or invalid credentials.

swagger:response schemaThingsPropertiesUpdateUnauthorized
*/
type SchemaThingsPropertiesUpdateUnauthorized struct {
}

// NewSchemaThingsPropertiesUpdateUnauthorized creates SchemaThingsPropertiesUpdateUnauthorized with default headers values
func NewSchemaThingsPropertiesUpdateUnauthorized() *SchemaThingsPropertiesUpdateUnauthorized {

	return &SchemaThingsPropertiesUpdateUnauthorized{}
}

// WriteResponse to the client
func (o *SchemaThingsPropertiesUpdateUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(401)
}

// SchemaThingsPropertiesUpdateForbiddenCode is the HTTP code returned for type SchemaThingsPropertiesUpdateForbidden
const SchemaThingsPropertiesUpdateForbiddenCode int = 403

/*SchemaThingsPropertiesUpdateForbidden Forbidden

swagger:response schemaThingsPropertiesUpdateForbidden
*/
type SchemaThingsPropertiesUpdateForbidden struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaThingsPropertiesUpdateForbidden creates SchemaThingsPropertiesUpdateForbidden with default headers values
func NewSchemaThingsPropertiesUpdateForbidden() *SchemaThingsPropertiesUpdateForbidden {

	return &SchemaThingsPropertiesUpdateForbidden{}
}

// WithPayload adds the payload to the schema things properties update forbidden response
func (o *SchemaThingsPropertiesUpdateForbidden) WithPayload(payload *models.ErrorResponse) *SchemaThingsPropertiesUpdateForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema things properties update forbidden response
func (o *SchemaThingsPropertiesUpdateForbidden) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaThingsPropertiesUpdateForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// SchemaThingsPropertiesUpdateUnprocessableEntityCode is the HTTP code returned for type SchemaThingsPropertiesUpdateUnprocessableEntity
const SchemaThingsPropertiesUpdateUnprocessableEntityCode int = 422

/*SchemaThingsPropertiesUpdateUnprocessableEntity Invalid update.

swagger:response schemaThingsPropertiesUpdateUnprocessableEntity
*/
type SchemaThingsPropertiesUpdateUnprocessableEntity struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaThingsPropertiesUpdateUnprocessableEntity creates SchemaThingsPropertiesUpdateUnprocessableEntity with default headers values
func NewSchemaThingsPropertiesUpdateUnprocessableEntity() *SchemaThingsPropertiesUpdateUnprocessableEntity {

	return &SchemaThingsPropertiesUpdateUnprocessableEntity{}
}

// WithPayload adds the payload to the schema things properties update unprocessable entity response
func (o *SchemaThingsPropertiesUpdateUnprocessableEntity) WithPayload(payload *models.ErrorResponse) *SchemaThingsPropertiesUpdateUnprocessableEntity {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema things properties update unprocessable entity response
func (o *SchemaThingsPropertiesUpdateUnprocessableEntity) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaThingsPropertiesUpdateUnprocessableEntity) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(422)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// SchemaThingsPropertiesUpdateInternalServerErrorCode is the HTTP code returned for type SchemaThingsPropertiesUpdateInternalServerError
const SchemaThingsPropertiesUpdateInternalServerErrorCode int = 500

/*SchemaThingsPropertiesUpdateInternalServerError An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.

swagger:response schemaThingsPropertiesUpdateInternalServerError
*/
type SchemaThingsPropertiesUpdateInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewSchemaThingsPropertiesUpdateInternalServerError creates SchemaThingsPropertiesUpdateInternalServerError with default headers values
func NewSchemaThingsPropertiesUpdateInternalServerError() *SchemaThingsPropertiesUpdateInternalServerError {

	return &SchemaThingsPropertiesUpdateInternalServerError{}
}

// WithPayload adds the payload to the schema things properties update internal server error response
func (o *SchemaThingsPropertiesUpdateInternalServerError) WithPayload(payload *models.ErrorResponse) *SchemaThingsPropertiesUpdateInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the schema things properties update internal server error response
func (o *SchemaThingsPropertiesUpdateInternalServerError) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *SchemaThingsPropertiesUpdateInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
