//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package things

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// ThingsDeleteNoContentCode is the HTTP code returned for type ThingsDeleteNoContent
const ThingsDeleteNoContentCode int = 204

/*ThingsDeleteNoContent Successfully deleted.

swagger:response thingsDeleteNoContent
*/
type ThingsDeleteNoContent struct {
}

// NewThingsDeleteNoContent creates ThingsDeleteNoContent with default headers values
func NewThingsDeleteNoContent() *ThingsDeleteNoContent {

	return &ThingsDeleteNoContent{}
}

// WriteResponse to the client
func (o *ThingsDeleteNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// ThingsDeleteUnauthorizedCode is the HTTP code returned for type ThingsDeleteUnauthorized
const ThingsDeleteUnauthorizedCode int = 401

/*ThingsDeleteUnauthorized Unauthorized or invalid credentials.

swagger:response thingsDeleteUnauthorized
*/
type ThingsDeleteUnauthorized struct {
}

// NewThingsDeleteUnauthorized creates ThingsDeleteUnauthorized with default headers values
func NewThingsDeleteUnauthorized() *ThingsDeleteUnauthorized {

	return &ThingsDeleteUnauthorized{}
}

// WriteResponse to the client
func (o *ThingsDeleteUnauthorized) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(401)
}

// ThingsDeleteForbiddenCode is the HTTP code returned for type ThingsDeleteForbidden
const ThingsDeleteForbiddenCode int = 403

/*ThingsDeleteForbidden Forbidden

swagger:response thingsDeleteForbidden
*/
type ThingsDeleteForbidden struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewThingsDeleteForbidden creates ThingsDeleteForbidden with default headers values
func NewThingsDeleteForbidden() *ThingsDeleteForbidden {

	return &ThingsDeleteForbidden{}
}

// WithPayload adds the payload to the things delete forbidden response
func (o *ThingsDeleteForbidden) WithPayload(payload *models.ErrorResponse) *ThingsDeleteForbidden {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the things delete forbidden response
func (o *ThingsDeleteForbidden) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ThingsDeleteForbidden) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(403)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// ThingsDeleteNotFoundCode is the HTTP code returned for type ThingsDeleteNotFound
const ThingsDeleteNotFoundCode int = 404

/*ThingsDeleteNotFound Successful query result but no resource was found.

swagger:response thingsDeleteNotFound
*/
type ThingsDeleteNotFound struct {
}

// NewThingsDeleteNotFound creates ThingsDeleteNotFound with default headers values
func NewThingsDeleteNotFound() *ThingsDeleteNotFound {

	return &ThingsDeleteNotFound{}
}

// WriteResponse to the client
func (o *ThingsDeleteNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(404)
}

// ThingsDeleteInternalServerErrorCode is the HTTP code returned for type ThingsDeleteInternalServerError
const ThingsDeleteInternalServerErrorCode int = 500

/*ThingsDeleteInternalServerError An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.

swagger:response thingsDeleteInternalServerError
*/
type ThingsDeleteInternalServerError struct {

	/*
	  In: Body
	*/
	Payload *models.ErrorResponse `json:"body,omitempty"`
}

// NewThingsDeleteInternalServerError creates ThingsDeleteInternalServerError with default headers values
func NewThingsDeleteInternalServerError() *ThingsDeleteInternalServerError {

	return &ThingsDeleteInternalServerError{}
}

// WithPayload adds the payload to the things delete internal server error response
func (o *ThingsDeleteInternalServerError) WithPayload(payload *models.ErrorResponse) *ThingsDeleteInternalServerError {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the things delete internal server error response
func (o *ThingsDeleteInternalServerError) SetPayload(payload *models.ErrorResponse) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *ThingsDeleteInternalServerError) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(500)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
