//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package actions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// NewActionsUpdateParams creates a new ActionsUpdateParams object
// with the default values initialized.
func NewActionsUpdateParams() *ActionsUpdateParams {
	var ()
	return &ActionsUpdateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewActionsUpdateParamsWithTimeout creates a new ActionsUpdateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewActionsUpdateParamsWithTimeout(timeout time.Duration) *ActionsUpdateParams {
	var ()
	return &ActionsUpdateParams{

		timeout: timeout,
	}
}

// NewActionsUpdateParamsWithContext creates a new ActionsUpdateParams object
// with the default values initialized, and the ability to set a context for a request
func NewActionsUpdateParamsWithContext(ctx context.Context) *ActionsUpdateParams {
	var ()
	return &ActionsUpdateParams{

		Context: ctx,
	}
}

// NewActionsUpdateParamsWithHTTPClient creates a new ActionsUpdateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewActionsUpdateParamsWithHTTPClient(client *http.Client) *ActionsUpdateParams {
	var ()
	return &ActionsUpdateParams{
		HTTPClient: client,
	}
}

/*ActionsUpdateParams contains all the parameters to send to the API endpoint
for the actions update operation typically these are written to a http.Request
*/
type ActionsUpdateParams struct {

	/*Body*/
	Body *models.Action
	/*ID
	  Unique ID of the Action.

	*/
	ID strfmt.UUID

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the actions update params
func (o *ActionsUpdateParams) WithTimeout(timeout time.Duration) *ActionsUpdateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the actions update params
func (o *ActionsUpdateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the actions update params
func (o *ActionsUpdateParams) WithContext(ctx context.Context) *ActionsUpdateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the actions update params
func (o *ActionsUpdateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the actions update params
func (o *ActionsUpdateParams) WithHTTPClient(client *http.Client) *ActionsUpdateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the actions update params
func (o *ActionsUpdateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the actions update params
func (o *ActionsUpdateParams) WithBody(body *models.Action) *ActionsUpdateParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the actions update params
func (o *ActionsUpdateParams) SetBody(body *models.Action) {
	o.Body = body
}

// WithID adds the id to the actions update params
func (o *ActionsUpdateParams) WithID(id strfmt.UUID) *ActionsUpdateParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the actions update params
func (o *ActionsUpdateParams) SetID(id strfmt.UUID) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *ActionsUpdateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID.String()); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
