//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewWeaviateWellknownLivenessParams creates a new WeaviateWellknownLivenessParams object
// with the default values initialized.
func NewWeaviateWellknownLivenessParams() *WeaviateWellknownLivenessParams {

	return &WeaviateWellknownLivenessParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewWeaviateWellknownLivenessParamsWithTimeout creates a new WeaviateWellknownLivenessParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewWeaviateWellknownLivenessParamsWithTimeout(timeout time.Duration) *WeaviateWellknownLivenessParams {

	return &WeaviateWellknownLivenessParams{

		timeout: timeout,
	}
}

// NewWeaviateWellknownLivenessParamsWithContext creates a new WeaviateWellknownLivenessParams object
// with the default values initialized, and the ability to set a context for a request
func NewWeaviateWellknownLivenessParamsWithContext(ctx context.Context) *WeaviateWellknownLivenessParams {

	return &WeaviateWellknownLivenessParams{

		Context: ctx,
	}
}

// NewWeaviateWellknownLivenessParamsWithHTTPClient creates a new WeaviateWellknownLivenessParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewWeaviateWellknownLivenessParamsWithHTTPClient(client *http.Client) *WeaviateWellknownLivenessParams {

	return &WeaviateWellknownLivenessParams{
		HTTPClient: client,
	}
}

/*WeaviateWellknownLivenessParams contains all the parameters to send to the API endpoint
for the weaviate wellknown liveness operation typically these are written to a http.Request
*/
type WeaviateWellknownLivenessParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the weaviate wellknown liveness params
func (o *WeaviateWellknownLivenessParams) WithTimeout(timeout time.Duration) *WeaviateWellknownLivenessParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the weaviate wellknown liveness params
func (o *WeaviateWellknownLivenessParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the weaviate wellknown liveness params
func (o *WeaviateWellknownLivenessParams) WithContext(ctx context.Context) *WeaviateWellknownLivenessParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the weaviate wellknown liveness params
func (o *WeaviateWellknownLivenessParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the weaviate wellknown liveness params
func (o *WeaviateWellknownLivenessParams) WithHTTPClient(client *http.Client) *WeaviateWellknownLivenessParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the weaviate wellknown liveness params
func (o *WeaviateWellknownLivenessParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *WeaviateWellknownLivenessParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
