//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package p2_p

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewP2pHealthParams creates a new P2pHealthParams object
// with the default values initialized.
func NewP2pHealthParams() *P2pHealthParams {

	return &P2pHealthParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewP2pHealthParamsWithTimeout creates a new P2pHealthParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewP2pHealthParamsWithTimeout(timeout time.Duration) *P2pHealthParams {

	return &P2pHealthParams{

		timeout: timeout,
	}
}

// NewP2pHealthParamsWithContext creates a new P2pHealthParams object
// with the default values initialized, and the ability to set a context for a request
func NewP2pHealthParamsWithContext(ctx context.Context) *P2pHealthParams {

	return &P2pHealthParams{

		Context: ctx,
	}
}

// NewP2pHealthParamsWithHTTPClient creates a new P2pHealthParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewP2pHealthParamsWithHTTPClient(client *http.Client) *P2pHealthParams {

	return &P2pHealthParams{
		HTTPClient: client,
	}
}

/*P2pHealthParams contains all the parameters to send to the API endpoint
for the p2p health operation typically these are written to a http.Request
*/
type P2pHealthParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the p2p health params
func (o *P2pHealthParams) WithTimeout(timeout time.Duration) *P2pHealthParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the p2p health params
func (o *P2pHealthParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the p2p health params
func (o *P2pHealthParams) WithContext(ctx context.Context) *P2pHealthParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the p2p health params
func (o *P2pHealthParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the p2p health params
func (o *P2pHealthParams) WithHTTPClient(client *http.Client) *P2pHealthParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the p2p health params
func (o *P2pHealthParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *P2pHealthParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
