//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2019 SeMI Holding B.V. (registered @ Dutch Chamber of Commerce no 75221632). All rights reserved.
//  LICENSE WEAVIATE OPEN SOURCE: https://www.semi.technology/playbook/playbook/contract-weaviate-OSS.html
//  LICENSE WEAVIATE ENTERPRISE: https://www.semi.technology/playbook/contract-weaviate-enterprise.html
//  CONCEPT: Bob van Luijt (@bobvanluijt)
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package schema

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/semi-technologies/weaviate/entities/models"
)

// NewSchemaThingsUpdateParams creates a new SchemaThingsUpdateParams object
// with the default values initialized.
func NewSchemaThingsUpdateParams() *SchemaThingsUpdateParams {
	var ()
	return &SchemaThingsUpdateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewSchemaThingsUpdateParamsWithTimeout creates a new SchemaThingsUpdateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSchemaThingsUpdateParamsWithTimeout(timeout time.Duration) *SchemaThingsUpdateParams {
	var ()
	return &SchemaThingsUpdateParams{

		timeout: timeout,
	}
}

// NewSchemaThingsUpdateParamsWithContext creates a new SchemaThingsUpdateParams object
// with the default values initialized, and the ability to set a context for a request
func NewSchemaThingsUpdateParamsWithContext(ctx context.Context) *SchemaThingsUpdateParams {
	var ()
	return &SchemaThingsUpdateParams{

		Context: ctx,
	}
}

// NewSchemaThingsUpdateParamsWithHTTPClient creates a new SchemaThingsUpdateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSchemaThingsUpdateParamsWithHTTPClient(client *http.Client) *SchemaThingsUpdateParams {
	var ()
	return &SchemaThingsUpdateParams{
		HTTPClient: client,
	}
}

/*SchemaThingsUpdateParams contains all the parameters to send to the API endpoint
for the schema things update operation typically these are written to a http.Request
*/
type SchemaThingsUpdateParams struct {

	/*Body*/
	Body *models.Class
	/*ClassName*/
	ClassName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the schema things update params
func (o *SchemaThingsUpdateParams) WithTimeout(timeout time.Duration) *SchemaThingsUpdateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the schema things update params
func (o *SchemaThingsUpdateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the schema things update params
func (o *SchemaThingsUpdateParams) WithContext(ctx context.Context) *SchemaThingsUpdateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the schema things update params
func (o *SchemaThingsUpdateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the schema things update params
func (o *SchemaThingsUpdateParams) WithHTTPClient(client *http.Client) *SchemaThingsUpdateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the schema things update params
func (o *SchemaThingsUpdateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the schema things update params
func (o *SchemaThingsUpdateParams) WithBody(body *models.Class) *SchemaThingsUpdateParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the schema things update params
func (o *SchemaThingsUpdateParams) SetBody(body *models.Class) {
	o.Body = body
}

// WithClassName adds the className to the schema things update params
func (o *SchemaThingsUpdateParams) WithClassName(className string) *SchemaThingsUpdateParams {
	o.SetClassName(className)
	return o
}

// SetClassName adds the className to the schema things update params
func (o *SchemaThingsUpdateParams) SetClassName(className string) {
	o.ClassName = className
}

// WriteToRequest writes these params to a swagger request
func (o *SchemaThingsUpdateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param className
	if err := r.SetPathParam("className", o.ClassName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
